<template>
    <div class="vue-alerts">
        <alert
            v-for="alert in alerts"
            :key="alert.id"
            :message="alert.message"
            :type="alert.type"
            :isClosing="alert.isClosing"

            @close="removeAlert(alert.id)"
        />
    </div>
</template>

<script>
    import Alert from "./Alert";
    import Vue from 'vue';

    export default {
        name: "AlertManager",
        components: { Alert },
        props: {
            clearTimer: {
                type: Number,
                default: 5000,
            }
        },
        data: function () {
            return {
                nextAlertId: 0,
                alerts: [],
            }
        },
        methods: {
            addAlert(AlertObject) {
                if (AlertObject.hasOwnProperty('console'))
                    this.consoleAlert(AlertObject.console, AlertObject.type);

                Object.assign(AlertObject, {id: this.nextAlertId++});
                this.alerts.push(AlertObject);
                setTimeout(() => this.removeAlert(AlertObject.id), AlertObject.timeout || this.clearTimer)
            },
            removeAlert(AlertObjectId) {
                let alertIndex = this.alerts.findIndex((elem) => elem.id === AlertObjectId);
                let removingAlert = this.alerts[alertIndex];
                Vue.set(this.alerts, alertIndex, Object.assign(removingAlert, {isClosing: true}));
                setTimeout(() => this.alerts.splice(alertIndex, 1), 500)
            },
            consoleAlert(ConsoleAlertObject, type = 'log') {
                let messages = ConsoleAlertObject.message;
                if (messages instanceof Array) {
                    for (let message in messages)
                        if (typeof messages[message] !== 'string')
                            messages[message] = JSON.stringify(messages[message]);

                    messages = messages.join('\n');

                }
                messages = '\n' + messages;

                switch (type) {
                    case 'warn':
                        console.warn(ConsoleAlertObject.method, messages);
                        break;
                    case 'danger':
                        console.error(ConsoleAlertObject.method, messages);
                        break;
                    case 'success':
                        console.info(ConsoleAlertObject.method, messages);
                        break;
                    default:
                        console.log(ConsoleAlertObject.method, messages);
                        break;
                }
            },
        },
        mounted: function () {
            this.$events.$on('alert', AlertObject => { this.addAlert(AlertObject) });
        }
    }
</script>

<style scoped>
.vue-alerts {
    position: fixed;
    bottom: 50px;
    right: 50px;
    max-width: 100%;
    width: 20vw;
    display: flex;
    flex-direction: column-reverse;
    z-index: 10000;
}
</style>